/*************************************************************************
*
*   ssltypes.h
*
*   This module contains SSL functions
*
*   $Id$
*
*   Copyright 2000-2010 Citrix Systems, Inc.  
*
*************************************************************************/

#ifndef _SSLERR_H_
#define _SSLERR_H_

#pragma once

#define SDKERROROFFSET 1000000
#define SSLERROROFFSET 1100000

#define iSSL_STATUS_SUCCESS (SDKERROROFFSET + 0)
#define iSSL_STATUS_RENEGOTIATE (SDKERROROFFSET + 1)
#define iSSL_STATUS_HANDSHAKE_COMPLETE (SDKERROROFFSET + 2)
#define iSSL_STATUS_UNKNOWN_ERROR (SDKERROROFFSET + 3)
#define iSSL_STATUS_NETWORK_ERROR (SDKERROROFFSET + 4)
#define iSSL_STATUS_INTERNAL_ERROR (SDKERROROFFSET + 5)
#define iSSL_STATUS_LIBRARY_NOT_AVAILABLE (SDKERROROFFSET + 6)
#define iSSL_STATUS_NO_ENTRY_POINT_DEFINED (SDKERROROFFSET + 7)
#define iSSL_STATUS_INITIALISATION_FAILED (SDKERROROFFSET + 8)
#define iSSL_STATUS_OUT_OF_MEMORY (SDKERROROFFSET + 9)
#define iSSL_STATUS_CREDENTIALS_NOT_FOUND (SDKERROROFFSET + 10)
#define iSSL_STATUS_CREDENTIALS_NOT_RECOGNISED (SDKERROROFFSET + 11)
#define iSSL_STATUS_CREDENTIALS_ACCESS_DENIED (SDKERROROFFSET + 12)
#define iSSL_STATUS_SSL_NOT_AVAILABLE (SDKERROROFFSET + 13)
#define iSSL_STATUS_INSUFFICIENT_SECURITY_AVAILABLE (SDKERROROFFSET + 14)
#define iSSL_STATUS_SECURITY_CONTEXT_INVALID (SDKERROROFFSET + 15)
#define iSSL_STATUS_BAD_SSL_PACKET (SDKERROROFFSET + 16)
#define iSSL_STATUS_BAD_SOCKS5_PACKET (SDKERROROFFSET + 17)
#define iSSL_STATUS_MESSAGE_ALTERED (SDKERROROFFSET + 18)
#define iSSL_STATUS_MESSAGE_OUT_OF_SEQUENCE (SDKERROROFFSET + 19)
#define iSSL_STATUS_MESSAGE_INCOMPLETE (SDKERROROFFSET + 20)
#define iSSL_STATUS_BAD_SOCKS5_METHOD_RESPONSE (SDKERROROFFSET + 21)
#define iSSL_STATUS_BAD_SOCKS5_CONNECT_RESPONSE (SDKERROROFFSET + 22)
#define iSSL_STATUS_UNSUPPORTED_SOCKS_ADDRESS_TYPE (SDKERROROFFSET + 23)
#define iSSL_STATUS_SEND_AND_TERMINATE (SDKERROROFFSET + 24)
#define iSSL_STATUS_PERFORM_REDIRECTION (SDKERROROFFSET + 25)
#define iSSL_STATUS_UNABLE_TO_OPEN_KEYSTORE (SDKERROROFFSET + 26)
#define iSSL_STATUS_UNABLE_TO_FIND_CERTIFICATE (SDKERROROFFSET + 27)
#define iSSL_STATUS_INVALID_SOCKET_TYPE (SDKERROROFFSET + 28)
#define iSSL_STATUS_SOCKS5_HANDSHAKE_FAILED (SDKERROROFFSET + 29)
#define iSSL_STATUS_BUFFER_TOO_SMALL (SDKERROROFFSET + 30)
#define iSSL_STATUS_INVALID_CONTEXT (SDKERROROFFSET + 31)
#define iSSL_STATUS_BAD_SOCKS5_METHOD_REQUEST (SDKERROROFFSET + 32)
#define iSSL_STATUS_BAD_SOCKS5_CONNECT_REQUEST (SDKERROROFFSET + 33)
#define iSSL_STATUS_SOCKS5_COMMAND_UNSUPPORTED (SDKERROROFFSET + 34)
#define iSSL_STATUS_REDIRECTION_ACCESS_FAILURE (SDKERROROFFSET + 35)
#define iSSL_STATUS_SOCKS5_NETWORK_UNREACHABLE (SDKERROROFFSET + 36)
#define iSSL_STATUS_SOCKS5_HOST_UNREACHABLE (SDKERROROFFSET + 37)
#define iSSL_STATUS_SOCKS5_CONNECTION_REFUSED (SDKERROROFFSET + 38)
#define iSSL_STATUS_SOCKS5_TTL_EXPIRED (SDKERROROFFSET + 39)
#define iSSL_STATUS_HOSTNAME_NOT_FOUND (SDKERROROFFSET + 40)
#define iSSL_STATUS_UNABLE_TO_CREATE_SOCKET (SDKERROROFFSET + 41)
#define iSSL_STATUS_CONNECTION_REFUSED (SDKERROROFFSET + 42)
#define iSSL_STATUS_ALERT_CLOSE_NOTIFY (SDKERROROFFSET + 43)
#define iSSL_STATUS_ALERT_UNEXPECTED_MESSAGE (SDKERROROFFSET + 44)
#define iSSL_STATUS_ALERT_BAD_MAC (SDKERROROFFSET + 45)
#define iSSL_STATUS_ALERT_DECOMPRESSION_FAILED (SDKERROROFFSET + 46)
#define iSSL_STATUS_ALERT_HANDSHAKE_FAILED (SDKERROROFFSET + 47)
#define iSSL_STATUS_ALERT_NO_CERTIFICATE (SDKERROROFFSET + 48)
#define iSSL_STATUS_ALERT_BAD_CERTIFICATE (SDKERROROFFSET + 49)
#define iSSL_STATUS_ALERT_UNSUPPORTED_CERT (SDKERROROFFSET + 50)
#define iSSL_STATUS_ALERT_CERTIFICATE_REVOKED (SDKERROROFFSET + 51)
#define iSSL_STATUS_ALERT_CERTIFICATE_EXPIRED (SDKERROROFFSET + 52)
#define iSSL_STATUS_ALERT_CERTIFICATE_UNKNOWN (SDKERROROFFSET + 53)
#define iSSL_STATUS_ALERT_ILLEGAL_PARAMETER (SDKERROROFFSET + 54)
#define iSSL_STATUS_ALERT_UNKNOWN (SDKERROROFFSET + 55)
#define iSSL_STATUS_UNABLE_TO_SET_VERIFY_PATHS (SDKERROROFFSET + 56)
#define iSSL_STATUS_UNABLE_TO_SET_CERTIFICATE (SDKERROROFFSET + 57)
#define iSSL_STATUS_UNABLE_TO_SET_KEY (SDKERROROFFSET + 58)
#define iSSL_STATUS_INVALID_COMMON_NAME (SDKERROROFFSET + 59)
#define iSSL_STATUS_X509ERR_DEPTH_ZERO_SELF_SIGNED_CERT (SDKERROROFFSET + 60)
#define iSSL_STATUS_X509ERR_UNABLE_TO_GET_ISSUER_CERT_LOCALLY (SDKERROROFFSET + 61)
#define iSSL_STATUS_X509ERR_UNABLE_TO_GET_ISSUER_CERT (SDKERROROFFSET + 62)
#define iSSL_STATUS_X509ERR_SELF_SIGNED_CERT_IN_CHAIN (SDKERROROFFSET + 63)
#define iSSL_STATUS_X509ERR_UNABLE_TO_VERIFY_LEAF_SIGNATURE (SDKERROROFFSET + 64)
#define iSSL_STATUS_X509ERR_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY (SDKERROROFFSET + 65)
#define iSSL_STATUS_X509ERR_CERT_SIGNATURE_FAILURE (SDKERROROFFSET + 66)
#define iSSL_STATUS_X509ERR_ERROR_IN_CERT_NOT_BEFORE_FIELD (SDKERROROFFSET + 67)
#define iSSL_STATUS_X509ERR_CERT_NOT_YET_VALID (SDKERROROFFSET + 68)
#define iSSL_STATUS_X509ERR_ERROR_IN_CERT_NOT_AFTER_FIELD (SDKERROROFFSET + 69)
#define iSSL_STATUS_X509ERR_CERT_HAS_EXPIRED (SDKERROROFFSET + 70)
#define iSSL_STATUS_UNIMPLEMENTED (SDKERROROFFSET + 71)
#define iSSL_STATUS_FAILED_TO_LOAD_ANY_CERTIFICATES (SDKERROROFFSET + 72)
#define iSSL_STATUS_FAILED_TO_LOAD_ALL_CERTIFICATES (SDKERROROFFSET + 73)
#define iSSL_STATUS_AUTHENTICATION_FAILURE (SDKERROROFFSET + 74)
#define iSSL_STATUS_TIMEOUT (SDKERROROFFSET + 75)
#define iSSL_STATUS_X509ERR_REVOKED (SDKERROROFFSET + 76)
#define iSSL_STATUS_X509ERR_REVOCATION_CHECK_FAILED (SDKERROROFFSET + 77)
#define iSSL_STATUS_X509ERR_NO_REVOCATION_PROVIDER (SDKERROROFFSET + 78)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_KEY_LENGTH (SDKERROROFFSET + 79)              
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_PATH_LENGTH (SDKERROROFFSET + 80)             
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_ENHANCED_KEY (SDKERROROFFSET + 81)  
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_NETSCAPE (SDKERROROFFSET + 82)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_CONSTRAINTS (SDKERROROFFSET + 83)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_KEY_USAGE (SDKERROROFFSET + 84)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_CRITICAL_EXTENSION (SDKERROROFFSET + 85)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_CERT_NAME (SDKERROROFFSET + 86)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_DATE_NESTING (SDKERROROFFSET + 87)
#define iSSL_STATUS_X509ERR_BAD_CERTIFICATE_CHAIN_LENGTH (SDKERROROFFSET + 88)

/* keep this in track with the highest error number
 */
#define iSSL_STATUS_LASTERROR              (SDKERROROFFSET + 88)

#define SSLERROR_CONNREFUSED       (SSLERROROFFSET + 0)
#define SSLERROR_NETUNREACH        (SSLERROROFFSET + 1)
#define SSLERROR_TIMEDOUT          (SSLERROROFFSET + 2)
#define SSLERROR_ILLEGALCOMMONNAME (SSLERROROFFSET + 3)
#define SSLERROR_NOTAVAILABLE      (SSLERROROFFSET + 4)

/* keep this in track with the highest error number
 */
#define SSLERROR_LASTERROR   (SSLERROROFFSET + 4)

#endif /* _SSLERR_H_ */
